import javax.swing.JPanel;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.*;
import javax.swing.BorderFactory;

public class DElementComponent extends JPanel implements AbstractComponent{

    // Text areas for element name and content.
    javax.swing.JTextField elementContent = new javax.swing.JTextField();
    public boolean selected = false;
    public boolean exists = false;
    int xtemp, ytemp;

    // Constructor
    public DElementComponent(){
	exists = true;
	super.setSize(new java.awt.Dimension(146, 30));
        super.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
        //super.setLocation(p);
        super.setVisible(true);
        super.setLayout(null);
        super.setToolTipText("Area for entering element details.");
        super.setBackground(java.awt.Color.lightGray);
	super.setBorder(BorderFactory.createLineBorder(java.awt.Color.lightGray));
        // event handling for the element component
        super.addMouseListener(new java.awt.event.MouseAdapter() {
                public void mouseClicked(java.awt.event.MouseEvent e) {
                    elementComponentMouseClicked(e);
                }
                public void mousePressed(java.awt.event.MouseEvent e) {
                    elementComponentMousePressed(e);
                }
                public void mouseReleased(java.awt.event.MouseEvent e) {
                    elementComponentMouseReleased(e);
                }
                public void mouseDragged(java.awt.event.MouseEvent e) {
                    elementComponentMouseDragged(e);
                }
            });

        elementContent.setToolTipText("Element content");
        elementContent.setVisible(true);
        elementContent.setSize(new java.awt.Dimension(130, 20));
        elementContent.setSelectedTextColor(java.awt.SystemColor.textHighlight);
        elementContent.setColumns(80);
        elementContent.setBackground(java.awt.Color.white);
        elementContent.setLocation(new java.awt.Point(10, 5));
	elementContent.setBorder(new javax.swing.plaf.BorderUIResource.EmptyBorderUIResource(new java.awt.Insets(0, 0, 0, 0)));

	this.add(elementContent);

    }

    public void rearrange(){}

    public void setContent(String s){
	elementContent.setText(s);
	elementContent.setToolTipText(s);
    }

    public void setLocation(Point p){
	super.setLocation(p);
    }

    public void setSize(java.awt.Dimension d){
	super.setSize(d);
    }

    public Dimension getSize() {
	return super.getSize();
    }

    public void add(AbstractComponent a){
	if (selected == true){
	    System.out.println("Cannot add stuff to elements ");
	}

    }
    
    public void toggleSelect(){
	if (selected){
	    selected = false;
	    //super.setBackground(new java.awt.Color(255,153,0));
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.lightGray));
	    repaint();
	} else {
	    selected = true;
	    //super.setBackground(new java.awt.Color(255,153,100));
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.red));
	    repaint();
	}
    }

    public String genQuery() {
	String name, content;
	content = elementContent.getText();
	/*if (content.equals("")){
	    return("(Elem \"" + name + "\" [])");
	} else {
	    return("(Elem \"" + name + "\" [(EText \"" + content + "\")])");
	    }*/
	return content;

    }

    // updateClick makes sure this Object does not get deleted unless specifically selected
    public void updateClick(){
        selected = false;
    }


    public void elementComponentMouseClicked(MouseEvent e){
	System.out.println("Element clicked: " + selected);
	if (selected){
	    selected = false;
	    //super.setBackground(new java.awt.Color(255,153,0));
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.lightGray));
	    //System.out.println("Parent is : " + getParent());
	    repaint();
	} else {
	    selected = true;
	    //super.setBackground(new java.awt.Color(255,153,100));
	    super.setBorder(BorderFactory.createLineBorder(java.awt.Color.red));
	    repaint();
	}
    }

    public void elementComponentMousePressed(MouseEvent e) {
        e.consume();
        System.out.println("Mouse pressed on: " + e.getPoint());
        xtemp = e.getX();
        ytemp = e.getY();
        //super.setLocation(e.getPoint());
    }
    
    public void elementComponentMouseReleased(MouseEvent e) {
        e.consume();
        //System.out.println("Mouse released on element: " + e.getPoint());
        super.setLocation(super.getX() + e.getX() - xtemp, super.getY() + e.getY() - ytemp);
        xtemp = 0;
        ytemp = 0;
	((AbstractComponent) getParent()).moved(this);
    }
    
    public void elementComponentMouseDragged(MouseEvent e) {
        e.consume();
        //System.out.println("Mouse dragged : " + e.getX() + " " + e.getY());
        super.setLocation(e.getPoint());
    }

    public void moved(AbstractComponent a){}

    public boolean isSelected(){
	return selected;
    }

    public void erase(){}

}
	
