import java.awt.*;
import java.awt.event.*;

public class ProgressFrame extends javax.swing.JFrame {

	// member declarations
	javax.swing.JPanel progressPanel = new javax.swing.JPanel();
	javax.swing.JProgressBar progressBar = new javax.swing.JProgressBar(0,100);

	public ProgressFrame() {
	}

	public void initComponents() throws Exception {
		// the following code sets the frame's initial state
		progressPanel.setSize(new java.awt.Dimension(350, 60));
		progressPanel.setBorder(new javax.swing.border.LineBorder(java.awt.Color.black, 1));
		progressPanel.setLocation(new java.awt.Point(0, 0));
		progressPanel.setVisible(true);
		progressPanel.setLayout(null);
		progressPanel.setBackground(new java.awt.Color(255, 153, 0));
		progressBar.setSize(new java.awt.Dimension(310, 20));
		//progressBar.setString("Query Execution");
		progressBar.setLocation(new java.awt.Point(20, 20));
		progressBar.setVisible(true);
		progressBar.setBackground(new java.awt.Color(255, 153, 0));
		progressBar.setStringPainted(false);
		setLocation(new java.awt.Point(0, 0));
		getContentPane().setLayout(null);
		setTitle("Query Execution");
		setResizable(false);
		setBackground(new java.awt.Color(255, 153, 0));

		progressPanel.add(progressBar);
		getContentPane().add(progressPanel);

		setSize(new java.awt.Dimension(351, 91));

		// event handling
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				thisWindowClosing(e);
			}
		});

	}
  
  	private boolean mShown = false;

        public void setValue(int i){
	    progressBar.setValue(i);
	    progressBar.update(progressBar.getGraphics());
	    //validate();
	    //repaint();
        }
        
        public void setString(String s){
	    progressBar.setString(s);
	    progressBar.update(progressBar.getGraphics());
	    //validate();
	    //repaint();
	}
  	
	public void addNotify() {
		super.addNotify();
		
		if (mShown)
			return;
			
		// move components to account for insets
		Insets insets = getInsets();
		Component[] components = getComponents();
		for (int i = 0; i < components.length; i++) {
			Point location = components[i].getLocation();
			location.move(location.x, location.y + insets.top);
			components[i].setLocation(location);
		}

		mShown = true;
	}

	// Close the window when the close box is clicked
	void thisWindowClosing(java.awt.event.WindowEvent e) {
		setVisible(false);
		dispose();
		//System.exit(0);
	}
	
}
