import javax.swing.JPanel;
import javax.swing.JComponent;
import java.awt.Dimension;
import java.awt.Point;
import java.awt.event.*;
import java.util.Vector;
import java.awt.Graphics;

public class RuleComponent extends JPanel implements AbstractComponent{

    // Vector to store the folders in this rule.
    Vector folderVector = new Vector();

    // Text area for folder name
    //javax.swing.JTextField folderName = new javax.swing.JTextField();
    public boolean selected = false;
    public boolean exists = false;

    // Constructor
    public RuleComponent(){
	exists = true;
	super.setSize(new java.awt.Dimension(740, 670));
        super.setCursor(java.awt.Cursor.getPredefinedCursor(java.awt.Cursor.DEFAULT_CURSOR));
        super.setLocation(5,5);
        super.setVisible(true);
        super.setLayout(null);
        super.setBackground(java.awt.SystemColor.white);
	super.setToolTipText("Area for building rules using folders.");

        // event handling for the card component
        super.addMouseListener(new java.awt.event.MouseAdapter() {
                public void mouseClicked(java.awt.event.MouseEvent e) {
                    ruleComponentMouseClicked(e);
                }
            });


    }

    public void paintComponent(Graphics g){
        int h = getHeight();
        int w = getWidth();
        super.paintComponent(g);

    }

    //public void addFolder(FolderComponent tempFolder){
    //this.add((AbstractComponent) tempFolder);
    //}

    public void add(AbstractComponent a){
	// *** ensure that only folders get added here.
	if (a instanceof FolderComponent){
	    //System.out.println("adding folder to rule");
	    //(FolderComponent) a;
	    FolderComponent left = (FolderComponent) a; //new FolderComponent();
	    //left.addCardVector(((FolderComponent) a).getComponentVector());
	    FolderComponent right = new FolderComponent();
	    folderVector.clear();
	    left.setSize(new Dimension(320,640));
	    right.setSize(new Dimension(320,640));
	    left.setLocation(new Point(5,5));
	    right.setLocation(new Point(395,5));
	    folderVector.add(0,(FolderComponent) left);
	    folderVector.add(1,(FolderComponent) right);
	    super.add((FolderComponent) left);
	    super.add((FolderComponent) right);
	    repaint();
	} else if (a instanceof CardComponent){
	    //System.out.println("Size of rule = " + folderVector.size());
	    //System.out.println("Adding to folder 1");
	    //((FolderComponent) folderVector.get(0)).add((AbstractComponent)(new CardComponent())); //a);
	    ((FolderComponent) folderVector.get(0)).add((AbstractComponent) (new CardComponent())); //(AbstractComponent)(new CardComponent()));
	    //System.out.println("Adding to folder 2");
	    ((FolderComponent) folderVector.get(1)).add((AbstractComponent) (new CardComponent()));
	    repaint();
	} else {
	    ((FolderComponent) folderVector.get(0)).add((AbstractComponent) (new ElementComponent()));
	    ((FolderComponent) folderVector.get(1)).add((AbstractComponent) (new ElementComponent()));
	}
	this.toggleSelect();
	this.rearrange();
    }

    public void rearrange(){
	int height, width;
	((AbstractComponent) folderVector.get(0)).rearrange();
	((AbstractComponent) folderVector.get(1)).rearrange();
	if (((JComponent) folderVector.get(0)).getHeight() > ((JComponent) folderVector.get(1)).getHeight()) {
	    height = ((JComponent) folderVector.get(0)).getHeight();
	} else {
	    height = ((JComponent) folderVector.get(1)).getHeight();
	}
	width = super.getWidth();
	super.setSize(new Dimension(width,height));
    }

    public void setLocation(Point p){
	super.setLocation(p);
    }

    public void setSize(Dimension d){
	super.setSize(d);
    }

    public Dimension getSize(){
	return super.getSize();
    }

    public void toggleSelect(){
	if (selected == true) selected = false;
    }

    public String genQuery() {
	String name, subquery;
	return("p=" + ((AbstractComponent) folderVector.get(0)).genQuery() + "&r=" + ((AbstractComponent) folderVector.get(1)).genQuery());
    }

    // updateClick makes sure this Object does not get deleted unless specifically selected
    public void updateClick(){
        selected = false;
    }

    //public void mouseEntered(MouseEvent e){ }
    //public void mouseExited(MouseEvent e){ }
    //public void mousePressed(MouseEvent e){ }
    //public void mouseReleased(MouseEvent e){ }


    public void ruleComponentMouseClicked(MouseEvent e){
	System.out.println("Rule clicked");
	if (selected){
	    selected = false;
	} else {
	    selected = true;
	}
    }

    public void moved(AbstractComponent a){}

    public boolean isSelected(){
	if(((FolderComponent) folderVector.get(0)).isSelected() && ((FolderComponent) folderVector.get(1)).isSelected()){
	    return true;
	} else {
	    return false;
	}
    }

    public void erase(){
	// not possible to erase one panel from a rule.
	((FolderComponent) folderVector.get(0)).erase();
	((FolderComponent) folderVector.get(1)).erase();
    }

}
	
